# Contributing to Serpent.AI

While the very warm and unexpected reception from the community is appreciated, Serpent.AI will, for the foreseeable future, remain a personal project of [@nbrochu](https://github.com/nbrochu). It is a labor of love with a vision and as such, the adopted stance on external contributions will be stiffer than usual.

As a general principle, the following statement will hold true:

### Any unsolicited pull request will be automatically closed

This being said, there *are* ways of contributing to the project:

## Contributing to the Community Wiki

While still moderated, the wiki is currently open to anyone with a GitHub account. Feel free to add tips, gotchas or even entirely new articles. Translation efforts are also extremely appreciated.

## Reporting Issues

Found a bug? Something misbehaving? Reporting issues is a great and accessible way to improve the project for everyone.

## Fixing Issues

Pull requests for outstanding issues clearly labeled with *BUG* will be accepted.

## Performance Improvements

Pull requests demonstrating and including a significantly faster way of doing something Serpent.AI currently does will be accepted.

## Feature Requests

Got a feature idea? Start a GitHub issue describing your idea. A *SUGGESTION* label will be applied to it. The issue will be used for discussion. Accepted feature ideas will be labeled as *PLANNED FEATURE*

## Help Wanted

Issues can be tagged with a special *HELP WANTED* label. This is a call to anyone in the community to participate. Pull requests addressing those will be accepted.

*If you disapprove of the above contribution policy, keep in mind that the code is totally open with a very permissive license. You are absolutely free to start your own fork, even under a different name.*
